;===============================================================================;
;										;
;			    (: 19.02.02)		;
;										;
;===============================================================================; 

main 

m_100
	movlw	.2		;    DTMF
	movwf	Repeat		; 1:40mc, 2:60mc, 3:80mc 	
m_200
	call	p_dtmf

	movf	DTMF,f		; ***   ****
	btfss	STATUS,Z
	call	out_DTMF	
	goto	m_200		;     
				;   "0" ( DTMF >20 )
m_900
	clrwdt	
	goto	m_900	

;###########################<  >##########################	
;---------------------------------------------------------------------
;---------------------------------------------------------------------
out_DTMF			;     
				;  DTMF
	call	out_busy
	movf	DTMF,w	
	movwf	TXREG	
	return
out_busy
	clrwdt
	btfss	PIR1,TXIF		
	goto	out_busy
	return
;---------------------------------------------------------------------
p_dtmf				;   DTMF
	clrwdt			; WDT    >18 mc (2.3 )
				;    256 
	clrf	CScan		;      256 
	movlw	F697_1		
	movwf	FSR
	movlw	.16
	movwf	CScan
pd_100				;  16  
	clrf	INDF  
	incf	FSR,f
	decfsz	CScan,f
	goto	pd_100		

	movlw 	high 	dtmf_file	;   
	movwf	dtmf_page		;     
	movlw 	low 	dtmf_file
	movwf	dtmf_adrs
	
pd_200
	call	tab_dtmf	;   2   
        btfsc   CMCON,7       	
        comf    Byte1,f		
     	btfsc   CMCON,7       	
        comf    Byte2,f		

 	btfss	Byte1,0		;    ()
	incf	F697_1,f
	btfss	Byte1,1
	incf	F697_2,f
	btfss	Byte1,2
	incf	F770_1,f
	btfss	Byte1,3
	incf	F770_2,f
	btfss	Byte1,4
	incf	F852_1,f
	btfss	Byte1,5
	incf	F852_2,f
	btfss	Byte1,6
	incf	F941_1,f
	btfss	Byte1,7
	incf	F941_2,f
	btfss	Byte2,0
	incf	F1209_1,f
	btfss	Byte2,1
	incf	F1209_2,f
	btfss	Byte2,2
	incf	F1336_1,f
	btfss	Byte2,3
	incf	F1336_2,f
	btfss	Byte2,4
	incf	F1477_1,f
	btfss	Byte2,5
	incf	F1477_2,f
	btfss	Byte2,6
	incf	F1633_1,f
	btfss	Byte2,7
	incf	F1633_2,f

	decfsz	CScan,1
	goto	pd_200		;  1  70  (70x256=17920)	
				;   -  
	movlw	.136		;  128 +  
	subwf	F697_1,f	;   SIN+COS  Fxxx_1
	btfss	STATUS,C
	comf	F697_1,f
	movlw	.131
	subwf	F697_2,f
	btfss	STATUS,C
	comf	F697_2,f
	movf	F697_2,w
	addwf	F697_1,f
	movlw	.128
	subwf	F770_1,f
	btfss	STATUS,C
	comf	F770_1,f
	movlw	.127
	subwf	F770_2,f
	btfss	STATUS,C
	comf	F770_2,f
	movf	F770_2,w
	addwf	F770_1,f
	movlw	.130
	subwf	F852_1,f
	btfss	STATUS,C
	comf	F852_1,f
	movlw	.130
	subwf	F852_2,f
	btfss	STATUS,C
	comf	F852_2,f
	movf	F852_2,w
	addwf	F852_1,f
	movlw	.128
	subwf	F941_1,f
	btfss	STATUS,C
	comf	F941_1,f
	movlw	.128
	subwf	F941_2,f
	btfss	STATUS,C
	comf	F941_2,f
	movf	F941_2,w
	addwf	F941_1,f
	movlw	.130
	subwf	F1209_1,f
	btfss	STATUS,C
	comf	F1209_1,f
	movlw	.128
	subwf	F1209_2,f
	btfss	STATUS,C
	comf	F1209_2,f
	movf	F1209_2,w
	addwf	F1209_1,f
	movlw	.129
	subwf	F1336_1,f
	btfss	STATUS,C
	comf	F1336_1,f
	movlw	.129
	subwf	F1336_2,f
	btfss	STATUS,C
	comf	F1336_2,f
	movf	F1336_2,w
	addwf	F1336_1,f
	movlw	.135
	subwf	F1477_1,f
	btfss	STATUS,C
	comf	F1477_1,f
	movlw	.128
	subwf	F1477_2,f
	btfss	STATUS,C
	comf	F1477_2,f
	movf	F1477_2,w
	addwf	F1477_1,f
	movlw	.131
	subwf	F1633_1,f
	btfss	STATUS,C
	comf	F1633_1,f
	movlw	.125
	subwf	F1633_2,f
	btfss	STATUS,C
	comf	F1633_2,f	
	movf	F1633_2,w
	addwf	F1633_1,f	;   8x10=80 

	clrf	RTemp		;     
	movlw	F697_1		;    F697_1
	movwf	FSR

	movf	INDF,w		;  2 
	subwf	F770_1,w
	btfss	STATUS,C
	goto	pd_300
	incf	FSR,1		;     
	incf	FSR,1		;     
	bsf	RTemp,0		;    770 
pd_300
	movf	INDF,w		;  2 
	subwf	F852_1,w
	btfss	STATUS,C
	goto	pd_320
	movlw	F852_1		;     
	movwf	FSR		;     852
	bsf	RTemp,1		;    852 
pd_320
	movf	INDF,w		;  2 
	subwf	F941_1,w
	btfsc	STATUS,C
	bsf	RTemp,2		;    941 

	movlw	F1209_1		;    F1209_1
	movwf	FSR

	movf	INDF,w		;  2 
	subwf	F1336_1,w
	btfss	STATUS,C
	goto	pd_340
	incf	FSR,1		;     
	incf	FSR,1		;     
	bsf	RTemp,3		;    1336 
pd_340
	movf	INDF,w		;  2 
	subwf	F1477_1,w
	btfss	STATUS,C
	goto	pd_360
	movlw	F1477_1		;     
	movwf	FSR		;     F1477_1	
	bsf	RTemp,4		;    1477 
pd_360
	movf	INDF,w		;  2 
	subwf	F1633_1,w
	btfsc	STATUS,C
	bsf	RTemp,5		;    1633 

	btfss	RTemp,2		;    1,4,7,10
	goto	pd_400
	movlw	.10	
	movwf	RxDtmf
	goto	pd_500
pd_400	
	btfss	RTemp,1		
	goto	pd_420
	movlw	.7	
	movwf	RxDtmf
	goto	pd_500	
pd_420	
	btfss	RTemp,0		
	goto	pd_440
	movlw	.4	
	movwf	RxDtmf
	goto	pd_500	
pd_440	
	movlw	.1	
	movwf	RxDtmf
pd_500
	btfss	RTemp,5		;      
	goto	pd_520
	movlw	.3	
	addwf	RxDtmf,1
	goto	pd_600	
pd_520
	btfss	RTemp,4		
	goto	pd_540
	incf	RxDtmf,1
	incf	RxDtmf,1
	goto	pd_600	
pd_540
	btfsc	RTemp,3		
	incf	RxDtmf,1
pd_600				
	movlw	0x0D 		;    "0D"(   )
	subwf	RxDtmf,w
	btfsc	STATUS,Z
	goto	pd_700
				;    DTMF   
	movf	PrDtmf,w	;    DTMF	
	subwf	RxDtmf,w
	btfsc	STATUS,Z	
	goto	pd_800			
pd_700
	clrf	DTMF		;    =>    "0"
	movf	Repeat,w	;   
	movwf	CsDtmf
	movf	RxDtmf,w
	movwf	PrDtmf		;       
	return			;   "0"   DTMF
pd_800
	decfsz	CsDtmf,f	;   =>   
	return
				;      - 
	movf	RxDtmf,w	
	movwf	DTMF	
	return
	
;---------------------------------------------------------------------
tab_dtmf			;    2  
				;  .  DTMF  W-
	call	tab_00		
	movwf	Byte1
	call	tab_00		
	movwf	Byte2
	clrf	PCLATH		; 00 -      
	return			
tab_00					
	movf	dtmf_page,w	
	movwf	PCLATH		;     ..  W-
	incf	dtmf_adrs,f
	btfsc	STATUS,Z
	incf	dtmf_page,f	
	decf	dtmf_adrs,w
	movwf	PCL

dtmf_file

	include dtmf.tab	;     DTMF		

;---------------------------------------------------------------------
